from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Boolean, Int

Bam2Bed_V0_1_0 = CommandToolBuilder(tool="bam2bed", base_command=["bam2bed"], inputs=[ToolInput(tag="in_keep_header", input_type=String(optional=True), prefix="--keep-header", doc=InputDocumentation(doc="to preserve the header data from the SAM input as")), ToolInput(tag="in_all_reads", input_type=Boolean(optional=True), prefix="--all-reads", doc=InputDocumentation(doc="(-a)\nInclude both unmapped and mapped reads in output")), ToolInput(tag="in_split", input_type=Boolean(optional=True), prefix="--split", doc=InputDocumentation(doc="(-s)\nSplit reads with 'N' CIGAR operations into separate BED\nelements")), ToolInput(tag="in_split_with_deletions", input_type=Boolean(optional=True), prefix="--split-with-deletions", doc=InputDocumentation(doc="(-S)\nSplit reads with 'N' and 'D' CIGAR operations into\nseparate elements")), ToolInput(tag="in_reduced", input_type=Boolean(optional=True), prefix="--reduced", doc=InputDocumentation(doc="(-R)\nOnly print first six columns of output")), ToolInput(tag="in_do_not_sort", input_type=Boolean(optional=True), prefix="--do-not-sort", doc=InputDocumentation(doc="(-d)\nDo not sort BED output with sort-bed (not compatible with --output=starch)")), ToolInput(tag="in_max_mem", input_type=Int(optional=True), prefix="--max-mem", doc=InputDocumentation(doc="(-m <val>)\nSets aside <value> memory for sorting BED output. For example, <value> can\nbe 8G, 8000M or 8000000000 to specify 8 GB of memory (default is 2G)")), ToolInput(tag="in_sort_tmpdir", input_type=Int(optional=True), prefix="--sort-tmpdir", doc=InputDocumentation(doc="(-r <dir>)\nOptionally sets [dir] as temporary directory for sort data, when used in\nconjunction with --max-mem=[value], instead of the host's operating system\ndefault temporary directory")), ToolInput(tag="in_starch_bzip_two", input_type=Boolean(optional=True), prefix="--starch-bzip2", doc=InputDocumentation(doc="(-z)\nUsed with --output=starch, the compressed output explicitly applies the bzip2\nalgorithm to compress intermediate data (default is bzip2)")), ToolInput(tag="in_starch_gzip", input_type=Boolean(optional=True), prefix="--starch-gzip", doc=InputDocumentation(doc="(-g)\nUsed with --output=starch, the compressed output applies gzip compression on\nintermediate data")), ToolInput(tag="in_starch_note", input_type=Boolean(optional=True), prefix="--starch-note", doc=InputDocumentation(doc="='xyz...' (-e 'xyz...')\nUsed with --output=starch, this adds a note to the Starch archive metadata"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Bam2Bed_V0_1_0().translate("wdl", allow_empty_container=True)

